/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package IntermediaryCode;

import java.util.HashMap;
import templates.FunctionInterface;

/**
 *
 * @author EUGENIO CARVALHO
 */
public class IRTemplate implements templates.TemplateDescription {

    public HashMap<String, String> Formats() throws Exception {

        return new HashMap<String, String>() {
            {
                String base = "{[PAD(global.position,G.addressLen,' ')]':'}"
                        + "{[T(1)]}"
                        + "{[PAD(block.position,G.addressLen,' ')]':'}"
                        + "{[T(2)]}";

                String end = "{[T(2)]}"
                        + "{'  T< '[type]' >'} "
                        + "{[T(2)]}"
                        + "{[basicBlock]}";

                put("label", "{[PAD(global.position,G.addressLen,' ')]':'}{[T(2)]}{'<'[label]'>'}':'");
                put("assign", base + "{[dst]}' := '{[p1]}{' '[op]' '}{[p2]}{' --'[comment]}" + end);
                put("pointer_assign", base + "{[dst.pointer]}{[dst]' := '}{[op]}{[p1]}{' --'[comment]}" + end);
                put("unary", base + " {[dst]} ' := '{[op]' '}{[p1]} {' --'[comment]}" + end);
                put("copy", base + " {[dst]} ' := '{[p1]} {' --'[comment]}" + end);
                put("memory", base + " {[type]} ' '{[p1]} {' --'[comment]}" + end);
                put("jump", base + " 'goto ' {'<'[label]'>'} {' --'[comment]}" + end);
                put("branch", base + " 'if '{[p1]} {' '[op]' '} {[p2]} ' goto ' {'<'[label]'>'} {' --'[comment]}" + end);
                put("call", base + " {[dst]' := '} 'call <' {[funcname]} '>, ' {[nump]} {' --'[comment]}" + end);
                put("return", base + " 'return ' {[p1]} {' --'[comment]}" + end);
                put("push_param", base + " 'push_param '{[p1]} {' --'[comment]}" + end);
                put("push_return", base + " 'push_return '{[p1]} {' --'[comment]}" + end);
                put("pop_param", base + " 'pop_param '{[p1]} {' --'[comment]}" + end);
                put("pop_return", base + " 'pop_return '{[p1]} {' --'[comment]}" + end);
            }
        };
    }

    public HashMap<String, FunctionInterface> Functions() throws Exception {
        return null;
    }
}
